<template>
  <div class="container h-100 d-flex justify-content-center align-items-center">
    <div class="col-lg-6">
      <h1 class="text-center mb-4">Login</h1>
      <div v-if="serverMessage" class="alert" :class="serverMessage.type">
      {{ serverMessage.text }}
    </div>
      <div class="card">
        <div class="card-body">
          <form @submit.prevent="login">
            <div class="form-group">
              <label for="username">Username</label>
              <input type="text" class="form-control" id="email" v-model="loginRequest.username" aria-describedby="emailHelp" placeholder="Enter email">
            </div>
            <div style="margin-bottom: 1cm;" class="form-group">
              <label for="password">Password</label>
              <input type="password" class="form-control" id="password" v-model="loginRequest.password" placeholder="Password">
            </div>
            
            <button type="submit" class="btn btn-primary btn-block">Submit</button>  &nbsp;&nbsp;&nbsp;
            <router-link class="btn btn-success btn-block" to="/register">Register</router-link>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { LOGIN_REQUEST } from "../api/api.js";
import CryptoJS from 'crypto-js';

export default {
  name: 'LoginView',
   data() {
    return {
      loginRequest: {
        username: "",
        password: "",
      },
      serverMessage: null,
    };
  },
    methods: {
    login() {
       // Sanitize inputs
      LOGIN_REQUEST(this.loginRequest)
        .then((res) => {
          if (res.accessToken) {
            // Derive a key from the username and password
            const key = CryptoJS.PBKDF2(this.loginRequest.password, this.loginRequest.username, { keySize: 128/32 }).toString();
            // Decrypt the private key
            const bytes = CryptoJS.AES.decrypt(res.privateKey, key);
            const privateKey = bytes.toString(CryptoJS.enc.Utf8);

             // Store the private key in local storage
            localStorage.setItem('privateKey', privateKey);
            
            // Store the username in the Vuex store
            this.$store.commit('SET_CURRENT_USER', this.loginRequest.username);

            sessionStorage.setItem("token", JSON.stringify(res));
            this.$router.push({ path: "/" });
            this.serverMessage = { type: 'alert-success', text: 'Login successful!' };
          } else {
            console.log(res);
            this.serverMessage = { type: 'alert-danger', text: res.message };
          }
        })
        .catch((e) => {
          console.log(e);
          this.serverMessage = { type: 'alert-danger', text: 'An error occurred.' };
        });
    },
    sanitizeInput(input) {
    // Remove script tags, encode special characters, or use a library like DOMPurify
    return input.replace(/<script.*?>.*?<\/script>/gi, '').trim();
  },
  }
}
</script>

<style scoped>
.container {
  height: 100vh; /* Full height of the viewport */
}
</style>